apiVersion: apps/v1
kind: Deployment
metadata:
  name: gateway-deployment
spec:
  selector:
    matchLabels:
      app: gateway 
  template:
    metadata:
      labels:
        app: gateway
    spec:
      containers:
      - name: gateway 
        image: avengerist/gateway:<COMMIT_HASH>
        ports:
        - containerPort: 8080
        env:
          - name: GATEWAY_PORT
            value: "8080"
          - name: MANAGEMENT_IP
            value: management-svc
          - name: MANAGEMENT_PORT
            value: "3000"
          - name: RABBITMQ_IP
            value: rabbitmq-svc
---
apiVersion: v1
kind: Service
metadata:
  name: gateway-svc
spec:
  selector:
    app: gateway
  type: LoadBalancer
  ports:
  - protocol: TCP
    port: 8080
    targetPort: 8080
---
apiVersion: autoscaling/v2
kind: HorizontalPodAutoscaler
metadata:
  name: gateway-autoscaling
spec:
  scaleTargetRef:
    apiVersion: apps/v1
    kind: Deployment
    name: gateway-deployment
  minReplicas: 1
  maxReplicas: 3
  metrics:
    - type: Resource
      resource:
        name: cpu
        target:
          type: Utilization
          averageUtilization: 60
